
; Mike's first module which uses the Rob/Andy/Dennis etc... 3D stuff
; Copyright (c) 1994 Atari Corp.

FLOORS EQU 8

; who knows when we'll need these
	include "jaguar.inc"
	include "blit.inc"
	include "joypad.inc"
	include "objlist.inc"

	.globl	input
	.globl	mike_stuff
	.globl  __CXM33

	.extern _Chunk_Forward
	.extern _Chunk_Backward
	.extern _Ch_Rol
	.extern _Ch_Ror
	.extern _Drive
	.extern _Dr_Speed
	.extern _Auto_Drive
	.globl  _Rotate

	.extern	do_sort
	.extern drawlist
	.extern scrublist
	.extern nturtles
	.extern do_turtle
	.extern gameover
	.extern rotate_flg
	.extern amb_flg
	.extern sun_flg
	.extern bulb_flg
	.extern ncubes
	.extern stretch
	.extern litemodel
	.extern ambient
	.extern sun
	.extern bulb
	.extern turtle
	
	.extern xposn
	.extern yposn
	.extern zposn
	.extern xrite
	.extern yrite
	.extern zrite
	.extern xdown
	.extern ydown
	.extern zdown
	.extern xhead
	.extern yhead
	.extern zhead
	
	.extern turtlnk
	.extern turtlsiz

	.extern	TURTLE_S
	.extern turtpak
	.extern	TURTLE_E
	.extern	gpuload
	.extern	gpurun
	.extern	gpuwait
	.extern  sun
	.extern  bulb
	

	.extern TXTCRZ_S
	.extern	text3D
	.extern	SORT_S
	.extern	bsort
	.extern TXTCRZ_E
	.extern	SORT_E
	.extern	cubesize		; Hand-Made Cube
	.extern cubedata
	.extern	gpuload
	.extern	gpurun
	.extern	gpuwait
	.extern	make_olist
	.extern	pad_now
	.extern	pad_shot
	.extern	readpad
;	.extern	turtlpak
	.extern	vblank
	.extern	vidinit
;	.extern	fastdraw
	.extern	Transform

	.extern	framecnt

	.extern	lastObj
	.extern objData

	.extern BuildObjList
	.extern	DISPBUF0
	.extern DISPBUF1
	.extern ZBUF


	.extern	TexVertPtr
	.extern	VertexPtr
	.extern	EndOfPack

	
;	.extern	vertlist
;	.extern	vlist2
		
				
input:
	movem.l	d0-d7/a0-a1,-(sp)

	lea	TURTLE_S,a0
	lea	turtpak,a1
	move.l	#TURTLE_E,d0
	sub.l	#TURTLE_S,d0
	jsr	gpuload		; Load Turtle Package into GPU

;
;	Handle ViewPoint Rotation and Translation
;
	move.l	pad_now,d0
	moveq	#0,	d1
	moveq	#0,	d2
	moveq	#0,	d3
	moveq	#0,	d4
	moveq	#0,	d5	; Move the camera
	moveq	#16,	d6	; moving speed
	moveq	#8,	d7	; turning speed

   move.l #turtle, a0  ; Now (a0) points to camera turtle		

Try_Fire_A:
	btst.l	#FIRE_A, d0
	beq	unhit_a
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; FIRE A ;;;;;;;;;;;;;;;;;;;;;;;
	cmpi	#1,		a_hit
	beq	skip_a

;	sub.w	#600,	yposn(a0)
	cmpi	#256, _Dr_Speed
	beq	Try_Fire_B
	
	move.l	_Dr_Speed, d6
	lsl.l	#1, d6
	move.l	d6, _Dr_Speed
	
	move.w	#1,		a_hit
	bra	Try_Fire_B
unhit_a:
	move.w	#0,		a_hit
skip_a:	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	


Try_Fire_B:
	btst.l	#FIRE_B, d0
	beq	Try_Fire_C
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; FIRE B ;;;;;;;;;;;;;;;;;;;;;;;
	move.w	#160, d6	; faster speed
	move.w	#20,  d7	; faster speed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

Try_Fire_C:
	btst.l	#FIRE_C, d0
	beq	unhit_c
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; FIRE C ;;;;;;;;;;;;;;;;;;;;;;;
	cmpi	#1,		c_hit
	beq	skip_c

	cmpi	#8, _Dr_Speed
	beq	Try_Up
	
	move.l	_Dr_Speed, d6
	lsr.l	#1, d6
	move.l	d6, _Dr_Speed
	
	move.w	#1,		c_hit
	bra	Try_Up
unhit_c:
	move.w	#0,		c_hit
skip_c:	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	


Try_Up:
	btst.l	#JOY_UP, d0
	beq	Try_Down
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Up ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;			add.w	d6,	d4		; forward
	movem.l	d0-d7/a0-a1,-(sp)
	jsr	_Chunk_Forward
	movem.l	(sp)+,d0-d7/a0-a1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
Try_Down:
	btst.l	#JOY_DOWN, d0
	beq	Try_Left
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Down ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;			sub.w	d6,	d4		; backward
	movem.l	d0-d7/a0-a1,-(sp)
	jsr	_Chunk_Backward
	movem.l	(sp)+,d0-d7/a0-a1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
Try_Left:
	btst.l	#JOY_LEFT, d0
	beq	Try_Right
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Left ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;			add.w		d7,	d2
	movem.l	d0-d7/a0-a1,-(sp)
	jsr	_Ch_Rol
	movem.l	(sp)+,d0-d7/a0-a1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
Try_Right:
	btst.l	#JOY_RIGHT, d0
	beq	Try1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Right ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;			sub.w		d7,	d2
	movem.l	d0-d7/a0-a1,-(sp)
	jsr	_Ch_Ror
	movem.l	(sp)+,d0-d7/a0-a1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
Try1:	btst.l	  #KEY_1, d0
	beq	  Try2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key 1 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       subq    #8, zposn(a0)	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try2:	btst.l	  #KEY_2, d0
	beq	  Try3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key 2 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   subq    #8, yposn(a0)	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try3:	btst.l	  #KEY_3, d0
	beq	  Try4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key 3 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   addq    #8, zposn(a0)	
;	sub.w		#64,	d2			; this is turn right
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try4:	btst.l	  #KEY_4, d0
	beq	  Try5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key 4 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   subq    #8, xposn(a0)	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try5:	btst.l	  #KEY_5, d0
	beq	  Try6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key 5 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   addq    #8, yposn(a0)	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try6:	btst.l	  #KEY_6, d0
	beq	  Try7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key 6 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   addq    #8, xposn(a0)	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try7:	btst.l	  #KEY_7, d0
	beq	  Try8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key 7 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	addq	  #2,	d1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try8:	btst.l	  #KEY_8, d0
	beq	  Try9
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key 8 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	move.w	#(14 * 2 * 128),	xposn(a0)
	move.w	#(9 * 2 * 128),   zposn(a0)
	move.w	#0,					yposn(a0)
	sub.w		#100,					yposn(a0)
	
	moveq	#0, d6
	move	#$4000,d7
	move	d7,xrite(a0)	; Init to Origin - Ordirnally aligned
	move	d6,yrite(a0)	; Init to Origin - Ordirnally aligned
	move	d6,zrite(a0)
	move	d6,xdown(a0)
	move	d7,ydown(a0)
	move	d6,zdown(a0)
	move	d6,xhead(a0)
	move	d6,yhead(a0)
	move	d7,zhead(a0)
	
;	add.w   #10000, xposn(a0) ; because it's also done in test.c
;	add.w   #10000, zposn(a0) ; because it's also done in test.c
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try9:	btst.l	  #KEY_9, d0
	beq	  Try0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key 9 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	moveq	#0, d6
	move	#$4000,d7
	move	d7,xrite(a0)	; Init to Origin - Ordirnally aligned
	move	d6,yrite(a0)	; Init to Origin - Ordirnally aligned
	move	d6,zrite(a0)
	move	d6,xdown(a0)
	move	d7,ydown(a0)
	move	d6,zdown(a0)
	move	d6,xhead(a0)
	move	d6,yhead(a0)
	move	d7,zhead(a0)
	
	move.w	#(14 * 2 * 128),	xposn(a0)
	move.w	#(9 * 2 * 128),   zposn(a0)
	move.w	#0,		yposn(a0)
	sub.w	#(600 * 14),	yposn(a0)
	
	add.w	  #64,	d1  ; look down
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try0:	btst.l	  #KEY_0, d0
	beq	  Try_Star
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key 0 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	subq	  #2,	d3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try_Star:	btst.l	  #KEY_STAR, d0
	beq	  Try_Hash
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key * ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	subq	  #2,	d1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try_Hash:	btst.l	  #KEY_HASH, d0
	beq	  Try_End
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Key # ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	addq	#2,	d3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Try_End:

	movem.l	d0-d7/a0-a1,-(sp)
	jsr	_Auto_Drive		; see what auto pilot wants to do
	movem.l	(sp)+,d0-d7/a0-a1
	
	movem.l	d0-d7/a0-a1,-(sp)
	jsr	_Drive		; yes, drive
	movem.l	(sp)+,d0-d7/a0-a1
	
	move.l	_Rotate, d2	; set by Drive

   moveq  #0, d0		 ;  move the camera
	jsr    do_turtle	; ViewPoint Rotation and Translation
	movem.l	(sp)+,d0-d7/a0-a1
	rts

__CXM33:
	movem.l   d2-d3,-(a7)
	move.l    d0,d2
	move.l    d1,d3
	swap      d2
	ext.l     d2
	beq.b     x0010
	mulu.w    d1,d2
x0010:	
	swap      d3
	ext.l     d3
	beq.w     x001c
	mulu.w    d0,d3
	add.w     d3,d2
x001c:	
	mulu.w    d1,d0
	swap      d2
	clr.w     d2
	add.l     d2,d0
	movem.l   (a7)+,d2-d3
	rts

if 0
Rotate_Model:
	movem.l	d0-d7/a0-a1,-(sp)
	; d0 is number of long-words triples (vertexes)
	; a0 is source
	; a1 is target
loop:
	move.l	(a0)+,	d1	; Swap first word of longwords 1 & 2
	move.l	(a0)+,	d2
	move.l	d1,	d3
	move.l	d2,	d4
	andi.l	#$0000FFFF, d1		; knock out X
	andi.l	#$0000FFFF, d2		; knock out Z
	andi.l	#$FFFF0000, d3		; leave X
	andi.l	#$FFFF0000, d4		; leave Z

	; negate X
	move.l	#16,	d5
	lsr.l	d5,	d3
	neg.w	d3
	lsl.l	d5,	d3
	
	or.l	d3,	d2
	or.l	d4,	d1
	move.l	d1,	(a1)+
	move.l	d2,	(a1)+
	move.l	(a0)+,	(a1)+		; leave 3rd word as is
	dbra	d0,	loop
	movem.l	(sp)+,d0-d7/a0-a1
	rts



mike_stuff:
	movem.l	d0-d7/a0-a1,-(sp)
	
	move.l	#vertlist,	a0
	move.l	#vlist2,	a1
	move.l	#(35 + (16 * FLOORS)), d0  ; was * 3
	jsr	Rotate_Model
	
	movem.l	(sp)+,d0-d7/a0-a1
	rts

endif


	.bss
	.even
	
a_hit:	.ds.w	1
c_hit:	.ds.w	1
	.phrase
	
_Rotate:	.ds.l	1
_Dr_Speed:	.ds.l	1

