;*******************************************************************************
;* TITLE	: STARTUP.S						       *
;* Function	: Startup Routines and Main Loop			       *
;*		  NOTE: Link this file <<<< FIRST >>>>			       *
;*									       *
;* Project #	: JAGUAR 3D pack out					       *
;*									       *
;* Programmer	: Cary J. Gee						       *
;*                                                                             *
;* COPYRIGHT 1992,1993 Atari U.S. Corporation				       *
;* UNATHORIZED REPRODUCTION, ADAPTATION, DISTRIBUTION, PERFORMANCE OR DISPLAY  *
;* OF THIS COMPUTER PROGRAM OR THE ASSOCIATED AUDIOVISUAL WORK IS STRICTLY     *
;* PROHIBITED.  ALL RIGHTS RESERVED.					       *
;*******************************************************************************

	.title	"STARTUP.S - System Startup Routines"

;*=============================================================================*
;* INCLUDE FILES							       *
;*=============================================================================*

	.include "jaguar.inc"
	.include "joypad.inc"
	.include "objlist.inc"

;*=============================================================================*
;* EXTERNAL ROUTINES							       *
;*=============================================================================*

	.extern	InitJag
	.extern	_main

;*=============================================================================*
;* EXTERNAL DATA							       *
;*=============================================================================*

;*=============================================================================*
;* PUBLIC ROUTINES							       *
;*=============================================================================*

	.globl	startup
	.globl	done

;*=============================================================================*
;* PUBLIC DATA								       *
;*=============================================================================*

	.globl	olist
	.globl	olist_ram

	.globl	DISPBUF0
	.globl	DISPBUF1
	.globl	ZBUF

	.globl	framecnt

;*=============================================================================*
;* LOCAL EQUATES							       *
;*=============================================================================*

BUFFERSIZE	EQU	(320*200*2)	; screen 320 X 200 in 16 bit color mode

;*******************************************************************************
;* SUBROUTINE AREA							       *
;*******************************************************************************

	.text

;*=============================================================================*
;* startup	- Link this file ******************* FIRST *********************
;*=============================================================================*

startup:
	jsr	InitJag
	jsr	_main
done:	rts

;*******************************************************************************
;* LOCAL RAM								       *
;*******************************************************************************

	.bss

;*=============================================================================*
;*=============================================================================*

		.phrase

olist:		.ds.l	2		; needed for bi-phrased
		.ds.l	(8*MAXOBJS)	; need 8 longs for each object
		.ds.l	2		; 2 longs for a stop object
olist_ram:	.ds.l	(8*MAXOBJS)	; 8 longs for each object
		.ds.l	2		; 2 longs for a stop object

		.phrase
NewScreen:
DISPBUF0:	.ds.b	3*BUFFERSIZE
DISPBUF1	equ	DISPBUF0+8
ZBUF		equ	DISPBUF1+8
SCREENPAD:	.ds.b	256

		.ds.l	2000		; 8k for stack
newstack:	.ds.l	1
framecnt:	.ds.l	1

		.phrase

;*******************************************************************************
;* END OF FILE								       *
;*******************************************************************************

	.end


